(function($){

if(typeof JAVirtuemart === "undefined")
	{
		var JAVirtuemart = {
			setproducttype : function (form, id) {
				form.view = null;
				var $ = jQuery, datas = form.serialize();
				var prices = form.parents(".productdetails").find(".product-price");
				if (0 == prices.length) {
					prices = $("#productPrice" + id);
				}
				datas = datas.replace("&view=cart", "");
				prices.fadeTo("fast", 0.75);
				$.getJSON(window.vmSiteurl + 'index.php?option=com_virtuemart&nosef=1&view=productdetails&task=recalculate&virtuemart_product_id='+id+'&format=json' + window.vmLang, encodeURIComponent(datas),
					function (datas, textStatus) {
						prices.fadeTo("fast", 1);
						// refresh price
						for (var key in datas) {
							var value = datas[key];
							if (value!=0) prices.find("span.Price"+key).show().html(value);
							else prices.find(".Price"+key).html(0).hide();
						}
					});
				return false; // prevent reload
			},
			productUpdate : function(mod) {
				var $ = jQuery ;
				$.ajaxSetup({ cache: false })
				$.getJSON(window.vmSiteurl+"index.php?option=com_virtuemart&nosef=1&view=cart&task=viewJS&format=json"+window.vmLang,
					function(datas, textStatus) {
						if (datas.totalProduct >0) {
							
							mod.find(".vm_cart_products .container").html("");
							$.each(datas.products, function(key, val) {
								
								$(".vmCartModule .vm_cart_products").each(function(){
									$(this).parent().find("#hiddencontainer .container").children().clone().appendTo($(this).find('.container'));
								});
								$.each(val, function(key, val) {
									if ($("#hiddencontainer .container ."+key)) mod.find(".vm_cart_products .container ."+key+":last").html(val) ;
								});
								
							});
							
							if($(".vmCartModule .showtotal").find(".total_products_bottom").length == 0){
								$('<div class="total_products_bottom"></div>').appendTo(".vmCartModule .showtotal");
							}
							if($(".vmCartModule .showtotal").find(".total").length == 0){
								$('<div class="total" style="float: right;"></div>').appendTo(".vmCartModule .showtotal");
							}
							if($(".vmCartModule .showtotal").find(".show_cart").length == 0){
								$('<div class="show_cart"></div>').appendTo(".vmCartModule .showtotal");
							}
							$(".vmCartModule .showtotal").find(".total_products_bottom").html(datas.totalProductTxt);
							$(".vmCartModule .showtotal").find(".total").html(datas.billTotal);
							$(".vmCartModule .showtotal").find(".show_cart").html(datas.cart_show);
						}
						mod.find(".total_products").html(datas.totalProductTxt);
					}
				);
			},
			sendtocart : function (form){
				JAVirtuemart.cartEffect(form) ;
			},
			cartEffect : function(form) {

					var $ = jQuery ;
					$.ajaxSetup({ cache: false })
					var datas = form.serialize();
					$.getJSON(vmSiteurl+'index.php?option=com_virtuemart&nosef=1&view=cart&task=addJS&format=json'+vmLang,encodeURIComponent(datas),
					function(datas, textStatus) {						
						if ($(".vmCartModule")[0]) {
							if($('.productdetails-view.productdetails .main-image img').length>0){
								flyToElement($('.productdetails-view.productdetails .main-image img'), $(".vmCartModule"));
							}
							if($(form).parent().parent().parent().find('div.vmproduct-image img').length>0){
								flyToElement($(form).parent().parent().parent().find('div.vmproduct-image img'), $(".vmCartModule"));
							}
							JAVirtuemart.productUpdate($(".vmCartModule"));
						}
					});
					$.ajaxSetup({ cache: true });
			},
			product : function(carts) {
				carts.each(function(){
					var cart = jQuery(this),
					step=cart.find('input[name="quantity"]'),
					addtocart = cart.find('input.ja-addtocart-button'),
					plus   = cart.find('.quantity-plus'),
					minus  = cart.find('.quantity-minus'),
					select = cart.find('select'),
					radio = cart.find('input:radio'),
					virtuemart_product_id = cart.find('input[name="virtuemart_product_id[]"]').val(),
					quantity = cart.find('.quantity-input');

                    var Ste = parseInt(step.val());
                    //Fallback for layouts lower than 2.0.18b
                    if(isNaN(Ste)){
                        Ste = 1;
                    }
					addtocart.click(function(e) { 
						
						JAVirtuemart.sendtocart(cart);
						return false;
					});
					plus.click(function() {
						var Qtt = parseInt(quantity.val());
						if (!isNaN(Qtt)) {
							quantity.val(Qtt + Ste);
						JAVirtuemart.setproducttype(cart,virtuemart_product_id);
						}
						
					});
					minus.click(function() {
						var Qtt = parseInt(quantity.val());
						if (!isNaN(Qtt) && Qtt>Ste) {
							quantity.val(Qtt - Ste);
						} else quantity.val(Ste);
						JAVirtuemart.setproducttype(cart,virtuemart_product_id);
					});
					select.change(function() {
						JAVirtuemart.setproducttype(cart,virtuemart_product_id);
					});
					radio.change(function() {
						JAVirtuemart.setproducttype(cart,virtuemart_product_id);
					});
					quantity.keyup(function() {
						JAVirtuemart.setproducttype(cart,virtuemart_product_id);
					});
				});

			}
		};
		jQuery.noConflict();
		jQuery(document).ready(function($) {

			javmaddcart = function(){
				JAVirtuemart.product($("form.ja-vm-product"));
	
				$("form.js-recalculate").each(function(){
					if ($(this).find(".product-fields").length) {
						var id= $(this).find('input[name="virtuemart_product_id[]"]').val();
						JAVirtuemart.setproducttype($(this),id);
	
					}
				});
			};
			javmaddcart();
		});
	}
})(jQuery);